﻿using System;
using System.Diagnostics;
using System.Windows.Forms;
using XA_DATASETLib;
using XA_SESSIONLib;

namespace XingAPIError
{
    public partial class Form1 : Form
    {
        private readonly XAQuery query;

        public Form1()
        {
            query = new XAQuery { ResFileName = @"Res\t1102.res" };
            query.ReceiveMessage += Query_ReceiveMessage;
            query.ReceiveData += Query_ReceiveData;

            var session = new XASession();
            if (session.ConnectServer("hts.ebestsec.co.kr", 0) == false) // 실서버
            //if (session.ConnectServer("demo.ebestsec.co.kr", 0) == false) // 데모서버
            {
                    Trace.WriteLine("Connect Error");
                return;
            }

            if (session.Login("아이디", "비밀번호", "인증서 암호", 0, false) == false)
            {
                Trace.WriteLine("Login Error");
                return;
            }

            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Request();
        }

        private void Form1_MouseClick(object sender, MouseEventArgs e)
        {
            Request();
        }

        private void Request()
        {
            query.SetFieldData("t1102InBlock", "shcode", 0, "005930");
            var res = query.Request(false);
            if (res < 0)
            {
                Trace.WriteLine($"Request Error - ErrorCode:{res}");
                return;
            }
        }

        private void Query_ReceiveMessage(bool bIsSystemError, string nMessageCode, string szMessage)
        {
            if (bIsSystemError == false)
                return;

            Trace.WriteLine($"Reply Error - MessageCode:{nMessageCode}, Message:{szMessage}");
        }

        private void Query_ReceiveData(string szTrCode)
        {
            Trace.WriteLine($"Reply Success - Current Price:{query.GetFieldData("t1102OutBlock", "price", 0)}");
        }
    }
}
